---
description: ""
title: How to Setup A Free, Fast, and Simple Blog Like This
draft: true
---

**TL;DR**: Netlify is incredible for hosting static websites. The code for this
entire site is available [here][repo]. I publish at-will using their CLI via
`netlify deploy --prod`. It's simple and awesome.

# Introduction

This website may not look like much, but that's *intentional*. It is simple
both in style, colors, and layout. It is blazing fast. It looks the same on any
device, mobile or otherwise. It uses the simple web technologies you already
know. You can use any static site generator such as [Hugo][hugo] or
[Gatsby][gatsby]. *And I don't pay for any of it to work!* I do pay for the
domain [`lyte.dev`](/), though, but you can get certain domains for completely
free.

And you can easily build on top of a system like this, extending it to do
anything you could ever possibly want! Need a Content Management System (CMS)?
[Done][netlify-cms]. Need to deploy a complicated Single-Page Application
(SPA)? [Easy][netlify-spa].

I'll show you how I put this together using tools already on your computer and
how you can extend my system to use whatever tools you prefer on top of my
basic ones.

Let's get started!

# How This Site Works

+ Obtain a domain and 
+ Publish the site at will using Netlify (their CLI is great!)



[netlify]: https://docs.netlify.com/cli/get-started/
[hugo]: https://gohugo.io/
[gatsby]: https://www.gatsbyjs.com/
[repo]: https://git.lyte.dev/lytedev/site.lyte.dev
[netlify-cms]: https://www.netlifycms.org/
[netlify-spa]: https://www.netlify.com/blog/2020/04/07/creating-better-more-predictable-redirect-rules-for-spas/
